﻿using UnityEngine;
using System.Collections;

public class DrawerInteraction : MonoBehaviour {

	Vector3 startPos;
	public Vector3 endPos;
	bool drawerOpen = false;
	float timer = 0f;
	bool opening = false;
	bool closing = false;


	// Use this for initialization
	void Start () {
		startPos = transform.localPosition;

	}
	
	// Update is called once per frame
	void Update(){
		if(opening){
			timer += Time.deltaTime;
			if(timer >= 1f){
				timer = 1f;
				transform.localPosition = endPos;
				opening = false;
				return;
			}
		}
		if(closing){
			timer -= Time.deltaTime;
			if(timer <= 0f){
				timer = 0f;
				transform.localPosition = startPos;
				closing = false;
				return;
			}
		}

		transform.localPosition = Vector3.Lerp(startPos, endPos, timer);
			
	}


	public void Activate () {
		if(drawerOpen){
			closing = true;
			opening = false;
		}else{
			closing = false;
			opening = true;
		}
		drawerOpen = !drawerOpen;
	}
}
