﻿using UnityEngine;
using System.Collections.Generic;
using UnityEngine.UI;
using System;

public class MessageBox : MonoBehaviour {

	public Text textTarget;
	private static List<string> messages;
	public float messageDuration = 5.0f;
	private float timer = 0f;
	private static bool interrupt = false;
	public Action onFinish;
	private static MessageBox _messageBox;
	

	// Use this for initialization
	void Awake () {
		messages = new List<string>();
		_messageBox = this;
	}
	
	// Update is called once per frame
	void Update () {
		if(interrupt){
			timer = 0f;
			textTarget.transform.parent.parent.gameObject.SetActive(false);
			interrupt = false;
		}
		if(messages.Count > 0){
			if(timer > 0f){
				//Currently displaying a message
				timer -= Time.deltaTime;
				if(Input.GetButtonUp("Select") || timer <= 0f){
					timer = 0f;
					messages.RemoveAt(0);
					if(messages.Count == 0){
						textTarget.transform.parent.parent.gameObject.SetActive(false);
						InputHandler.acceptingInput = true;
						if(onFinish != null){
							onFinish();
							onFinish = null;
						}
						return;
					}
				}
			}else{
				if(timer == 0f){
					//not displaying a message
					InputHandler.acceptingInput = false;
					textTarget.text = messages[0];
					timer = messageDuration;
					textTarget.transform.parent.parent.gameObject.SetActive(true);
				}
			}
		}
	
	}


	public static MessageBox AddMessage(string message){
		messages.Add(message);
		return _messageBox;
	}

	public static MessageBox NewMessage(string message){
		messages.Clear();
		interrupt = true;
		messages.Add(message);
		return _messageBox;
	}


}
