﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityStandardAssets.Characters.FirstPerson;
using UnityEngine.SceneManagement;

public class PhoneManager : MonoBehaviour {

	public bool phoneInUse = false;
	public bool activateYourPhone = false;
	public bool activateEmilyPhone = false;
	public bool closePhonePressed = false;
	public bool acceptingInput = true;
	public bool dialPressed = false;
	public bool cancelPressed = false;
	public static bool showYourPhone = false;
	public static bool showEmilyPhone = false;
	private string currentNumber = "";
	public GameObject phoneRoot;
	public GameObject yourScreen;
	public GameObject emilyScreen;
	public AudioSource phoneAudio;
	public AudioClip errorDigit;
	public AudioClip enterDigit;
	public AudioClip ringSound;
	public FirstPersonController fpController;
	public Text numberText;

	// Use this for initialization
	void Start () {
		phoneInUse = false;
		acceptingInput = true;
		currentNumber = "";
	}
	
	// Update is called once per frame
	void Update () {
		if(showYourPhone == true){
			showYourPhone = false;
			ShowYourPhone();
			if(fpController != null)
				fpController.setLockCursor(false);
		}
		if(showEmilyPhone == true){
			showEmilyPhone = false;
			ShowEmilyPhone();
		}

		if(yourScreen.activeSelf){
			numberText.text = GlobalVars.ParseNumber(currentNumber);
		}
	}

	public void DigitPressed(string number){
		//TODO: Play error sound?
		if(currentNumber.Length > 10){
			if(phoneAudio)
				phoneAudio.PlayOneShot(errorDigit);
			return;
		}
		//TODO: Play sound
		if(phoneAudio)
			phoneAudio.PlayOneShot(enterDigit);
		currentNumber += number;
	}

	public void Dial(){
		MessageBox m;
		if(currentNumber.Length == 10)
			currentNumber = "1" + currentNumber;
		if(currentNumber == "911" || currentNumber == "411" || currentNumber == "0"){
			m = MessageBox.AddMessage("On second thought, maybe not.");
			m.onFinish = () => {InputHandler.acceptingInput = false; currentNumber = "";};
			return;
		}else if(currentNumber == ""){
			m = MessageBox.AddMessage("I should put a number in first.");
			m.onFinish = () => {InputHandler.acceptingInput = false; currentNumber = "";};
			return;
		}else if(currentNumber.Length != 7 && currentNumber.Length != 11){
			m = MessageBox.AddMessage("That number won't get me anywhere.");
			m.onFinish = () => {InputHandler.acceptingInput = false; currentNumber = "";};
			return;
		}
		if(phoneAudio)
			phoneAudio.PlayOneShot(ringSound, .2f);
		switch(currentNumber){
		case "16022140857":
			//Tamika

			TamikaConversation();
			break;
		case "8311433":
			//Darron
			DarronConversation();
			break;
		default:
			if(phoneAudio)
				phoneAudio.PlayOneShot(ringSound);
			m = MessageBox.AddMessage("Huh, no answer.");
			m.onFinish = () => {InputHandler.acceptingInput = false; currentNumber = "";};
			break;
		}
	}

	public void ClearNumber(){
		if(phoneAudio)
			phoneAudio.PlayOneShot(errorDigit);
		currentNumber = "";
	}

	public void ShowYourPhone(){
		if(InputHandler.acceptingInput == false)
			return;
		InputHandler.acceptingInput = false;
		//phoneRoot.SetActive(true);
		//yourScreen.SetActive(true);
		InputHandler.acceptingInput = false;
		phoneRoot.SetActive(true);
		yourScreen.SetActive(true);
		currentNumber = "";

	}

	public void ShowEmilyPhone(){
		if(InputHandler.acceptingInput == false)
			return;
		if(GlobalVars.hasFoundCharger == false){
			MessageBox.NewMessage("It's no use, the phone's out of battery.");
			return;
		}
		if(GlobalVars.hasLearnedUnlockA == false || GlobalVars.hasLearnedUnlockB == false){
			if(!GlobalVars.phoneCharged){
				MessageBox.NewMessage("With the charger in hand, you manage to get the phone turned on.");
				MessageBox.AddMessage("Unfortunately, it's got a passcode unlock. The hint says 'mom's birthday'.");
				GlobalVars.phoneCharged = true;
				GlobalVars.knowsUnlockHint = true;
			}else{
				MessageBox.NewMessage("It's got a passcode unlock. The hint says 'mom's birthday'.");
			}
			return;
		}
			
		MessageBox m = MessageBox.NewMessage("Alright, 5-6-53...");
		MessageBox.AddMessage("I'm in! Hey there's some messages that look interesting.");
		m.onFinish = () =>{
			if(fpController != null)
				fpController.setLockCursor(false);
			InputHandler.acceptingInput = false;
			phoneRoot.SetActive(true);
			emilyScreen.SetActive(true);
		};

	}

	public void CloseButton(){
		yourScreen.SetActive(false);
		emilyScreen.SetActive(false);
		phoneRoot.SetActive(false);
		InputHandler.acceptingInput = true;
		fpController.setLockCursor(true);
	}

	void TamikaConversation(){
		MessageBox m = MessageBox.NewMessage("It's ringing.");
		if(GlobalVars.hasLearnedTamikaNumber == false){
			MessageBox.AddMessage("Hmm, no answer.");
		}else{
			if(GlobalVars.hasCalledTamika){
				MessageBox.AddMessage("<b>Tamika:</b> What you want?");
				if(GlobalVars.knowsUnlockHint){
					MessageBox.AddMessage("<b>You:</b> Do you know Emily's mom's birthday?");
					MessageBox.AddMessage("<b>Tamika:</b> June 5th.");
					MessageBox.AddMessage("<b>You:</b> Er, you knew that pretty quickly.");
					MessageBox.AddMessage("<b>Tamika:</b> In the spring semester, Emily flew off to her mom's without notice on the fifth, when she was supposed to proctor a final.");
					MessageBox.AddMessage("<b>You:</b> That would make it memorable.");
					MessageBox.AddMessage("<b>Tamika:</b> I'll say. I got a call about a classroom full of students with no tests to take. We had to reschedule. It was a nightmare.");
					MessageBox.AddMessage("<b>You:</b> Emily's not very good at teaching is she?");
					MessageBox.AddMessage("<b>Tamika:</b> Teaching's ok. It's the follow through that she has trouble with.");
					MessageBox.AddMessage("<b>You:</b> Well, thanks for your help.");
					MessageBox.AddMessage("<b>Tamika:</b> Sure thing. Let me know if you find her.");
					MessageBox.AddMessage("<b>You:</b> Will do. Bye.");
					GlobalVars.hasLearnedUnlockA = true;
				}else{
					MessageBox.AddMessage("<b>You:</b> Is there anything else you can tell me about Emily?");
					MessageBox.AddMessage("<b>Tamika:</b> Not really. I didn't know her that well. You really should ask Darron.");
					MessageBox.AddMessage("<b>You:</b> And you don't have his number?");
					MessageBox.AddMessage("<b>Tamika:</b> He's from your area code, I know that. Thought his number started with 831, but you never know. She'd have it around somewhere.");
					MessageBox.AddMessage("<b>You:</b> Well, I take a look around. Bye.");
				}
			}else{
				MessageBox.AddMessage("<b>Woman:</b> Who's this?");
				MessageBox.AddMessage("<b>You:</b> Er, hi, is this Tamika?");
				MessageBox.AddMessage("<b>Tamika:</b> Yeah this is Tamika, who are you?");
				if(GlobalVars.hasFoundPhone)
					MessageBox.AddMessage("<b>You:</b> This is a bit weird, but I'm trying to find someone named Emily. She left her phone, I think.");
				else
					MessageBox.AddMessage("<b>You:</b> This is a bit weird, but I'm trying to find someone named Emily.");
				MessageBox.AddMessage("<b>Tamika:</b> Emily? You know where she's at? She was supposed to turn in some grade reports to me a couple weeks ago.");
				MessageBox.AddMessage("<b>You:</b> No, I'm trying to find her. I moved into her old room, and she left some stuff behind.");
				MessageBox.AddMessage("<b>Tamika:</b> Did she leave her computer? I really need those reports. Administation's real upset.");
				MessageBox.AddMessage("<b>You:</b> I don't think so, no.");
				MessageBox.AddMessage("<b>Tamika:</b> Oh well. You should talk to Darron.");
				MessageBox.AddMessage("<b>You:</b> Who's Darron?");
				MessageBox.AddMessage("<b>Tamika:</b> He picks her up after lecture sometimes. He probably knows where she is.");
				MessageBox.AddMessage("<b>You:</b> You can't ask him?");
				MessageBox.AddMessage("<b>Tamika:</b> Don't remember his number too well. I think he's on vacation now, too.");
				MessageBox.AddMessage("<b>You:</b> Do you remember any of it?");
				MessageBox.AddMessage("<b>Tamika:</b> Are you from Texas? I think he's from your area code, so you won't even need it when you call.");
				MessageBox.AddMessage("<b>You:</b> That's convenient.");
				MessageBox.AddMessage("<b>Tamika:</b> I think the rest of the number started with 831, but I can't tell you more than that.");
				MessageBox.AddMessage("<b>You:</b> That's less convenient.");
				MessageBox.AddMessage("<b>Tamika:</b> Emily's a bit forgetful. She might have written it down somewhere.");
				MessageBox.AddMessage("<b>You:</b> Well, I suppose it's worth a try.");
				MessageBox.AddMessage("<b>Tamika:</b> Suppose so. I've grades to do, so good luck!");
				MessageBox.AddMessage("<b>You:</b> Yeah, you too, with those grades. Bye.");
			}
		}
		GlobalVars.hasLearnedDarronNumber = true;
		GlobalVars.hasCalledTamika = true;

		m.onFinish = () => {InputHandler.acceptingInput = false; currentNumber = "";};
	}

	void DarronConversation(){
		MessageBox m = MessageBox.NewMessage("It's ringing.");
		if(GlobalVars.hasLearnedDarronNumber == false){
			MessageBox.AddMessage("Hmm, no answer.");
		}else{
			if(GlobalVars.hasCalledDarron){
				MessageBox.AddMessage("<b>Darron:</b> You again, what do you need now?");
				if(GlobalVars.knowsUnlockHint){
					MessageBox.AddMessage("<b>You:</b> Do you know Emily's mom's birthday?");
					MessageBox.AddMessage("<b>Darron:</b> Why do you need to know that?");
					MessageBox.AddMessage("<b>You:</b> I found her phone and--");
					MessageBox.AddMessage("<b>Darron:</b> You're hacking her phone? Whatever, if you find her, I guess it's ok.");
					MessageBox.AddMessage("<b>You:</b> So you know her mom's birthday?");
					MessageBox.AddMessage("<b>Darron:</b> No. Why would I know that?");
					MessageBox.AddMessage("<b>You:</b> You'd know better than me.");
					MessageBox.AddMessage("<b>Darron:</b> Point. Her mom's the same age as mine, so she'd be... 53. That's 1963, isn't it?");
					MessageBox.AddMessage("<b>You:</b> That's a start at least.");
					MessageBox.AddMessage("<b>Darron:</b> Don't say I never gave you anything.");
					MessageBox.AddMessage("<b>You:</b> I won't. Thanks. Bye.");
					GlobalVars.hasLearnedUnlockB = true;
				}else{
					MessageBox.AddMessage("<b>You:</b> Where did you say I should look again?");
					MessageBox.AddMessage("<b>Darron:</b> There's some carpet she pulled up and put stuff in. One of the corners of her room. I never saw it, though.");
					MessageBox.AddMessage("<b>You:</b> Nothing else?");
					MessageBox.AddMessage("<b>Darron:</b> No, now let me get some sleep.");
					MessageBox.AddMessage("<b>You:</b> Sure, bye.");
				}
			}else{
				MessageBox.AddMessage("<b>Man:</b> Do you know what time it is?");
				MessageBox.AddMessage("<b>You:</b> In Texas? It's 10.");
				MessageBox.AddMessage("<b>Man:</b> Yeah, ten in the morning. Who calls someone that early?");
				MessageBox.AddMessage("<b>You:</b> Sorry if I woke you up. Are you Darron?");
				MessageBox.AddMessage("<b>Darron:</b> Yeah.");
				MessageBox.AddMessage("<b>You:</b> I'm looking for Emily. Do you know where I might find her?");
				MessageBox.AddMessage("<b>Darron:</b> Emily's done disappeared.");
				MessageBox.AddMessage("<b>You:</b> Well, that's why I'm looking for her.");
				MessageBox.AddMessage("<b>Darron:</b> Search me. I haven't heard from her since last month.");
				MessageBox.AddMessage("<b>You:</b> Where could she have gone?");
				MessageBox.AddMessage("<b>Darron:</b> I dunno. Hope it's somewhere nice. I heard she left her class high and dry.");
				MessageBox.AddMessage("<b>You:</b> Yeah, Tamika told me.");
				MessageBox.AddMessage("<b>Darron:</b> She leave anything?");
				if(GlobalVars.hasFoundPhone)
					MessageBox.AddMessage("<b>You:</b> Her phone's here, but it's dead.");
				else
					MessageBox.AddMessage("<b>You:</b> Just some books, it seems.");
				MessageBox.AddMessage("<b>Darron:</b> What about her security box?");
				MessageBox.AddMessage("<b>You:</b> What security box?");
				MessageBox.AddMessage("<b>Darron:</b> She's got a padlocked metal box somewhere. Said she keeps it under a corner of the carpet.");
				MessageBox.AddMessage("<b>You:</b> I haven't fount it.");
				MessageBox.AddMessage("<b>Darron:</b> Maybe she left it. Might have some clue where she's got to.");
				MessageBox.AddMessage("<b>You:</b> I'll look around for it then.");
				MessageBox.AddMessage("<b>Darron:</b> You do that. I'm going back to bed.");
				MessageBox.AddMessage("<b>You:</b> Well goodnight, then.");
			}
		}
		GlobalVars.hasLearnedOfBox = true;
		GlobalVars.hasCalledDarron = true;

		m.onFinish = () => {InputHandler.acceptingInput = false; currentNumber = "";};
	}

	public void EmilyConversation(){
		if(phoneAudio)
			phoneAudio.PlayOneShot(ringSound, .2f);
		MessageBox m = MessageBox.NewMessage("It's ringing.");
		MessageBox.AddMessage("<b>Woman:</b> Hello? Hannah?");
		MessageBox.AddMessage("<b>You:</b> No, it's not Hannah. Are you Emily?");
		MessageBox.AddMessage("<b>Emily:</b> Yes, that's me. Who is this?");
		MessageBox.AddMessage("<b>You:</b> I moved into your room at Hannah's place.");
		MessageBox.AddMessage("<b>Emily:</b> She gave away my room? I suppose I deserve that.");
		MessageBox.AddMessage("<b>You:</b> You did leave without any word.");
		MessageBox.AddMessage("<b>Emily:</b> I did... but I had a good reason!");
		MessageBox.AddMessage("<b>You:</b> What happened?");
		MessageBox.AddMessage("<b>Emily:</b> First, is Delilah ok? I left her there all alone and I've been worrying about it ever since.");
		MessageBox.AddMessage("<b>You:</b> Yeah, she seems just fine.");
		MessageBox.AddMessage("<b>Emily:</b> Oh, good.");
		MessageBox.AddMessage("<b>You:</b> That's more than I can say about Tamika.");
		MessageBox.AddMessage("<b>Emily:</b> Eep. I know. I was going to send her the grades, but my computer got fried on the way over here.");
		MessageBox.AddMessage("<b>You:</b> Over where? Where did you end up?");
		MessageBox.AddMessage("<b>Emily:</b> I'm in Khartoum.");
		MessageBox.AddMessage("<b>You:</b> Khartoum? Isn't that in Sudan? What are you doing there?");
		MessageBox.AddMessage("<b>Emily:</b> You heard about the dieoff in the Nile, right?");
		MessageBox.AddMessage("<b>You:</b> I don't think so.");
		MessageBox.AddMessage("<b>Emily:</b> Yeah, well there are a ton of fish dying in the Nile. A friend of mine from EcoWorld was going there to help investigate. He needed an assistant and asked me of all people.");
		MessageBox.AddMessage("<b>You:</b> And you ran off without saying a word to anyone?");
		MessageBox.AddMessage("<b>Emily:</b> It was very sudden, and I couldn't say a word. If anyone found out he was going there, any human factors of the dieoff might have gotten wind...");
		MessageBox.AddMessage("<b>You:</b> And you couldn't trust your friends? Your roommate?");
		MessageBox.AddMessage("<b>Emily:</b> I know it was hasty, but I couldn't pass up the opportunity to do this. This is exactly what I'm in my grad program to do!");
		MessageBox.AddMessage("<b>You:</b> You might not be in a grad program when you come back.");
		MessageBox.AddMessage("<b>Emily:</b> Yeah, I know. But I might secure a job with EcoWorld. If I do, I don't need a degree.");
		MessageBox.AddMessage("<b>You:</b> I guess I'm not too different from you. I just left my whole world in Texas for a job at Conrad here.");
		MessageBox.AddMessage("<b>Emily:</b> Conrad's the big tech company in Pecos, right?");
		MessageBox.AddMessage("<b>You:</b> Yeah. I'm nervous about it. I mean, what if I don't live up to their expectations?");
		MessageBox.AddMessage("<b>Emily:</b> Nervous, try rushing halfway across the world in a night and then spending the next day taking samples from rotting fish.");
		MessageBox.AddMessage("<b>You:</b> Eugh.");
		MessageBox.AddMessage("<b>Emily:</b> This is the job I wanted. Is Conrad the job you wanted?");
		MessageBox.AddMessage("<b>You:</b> Realistically, if I worked with their tech for the rest of my life, I'd be quite ok with it.");
		MessageBox.AddMessage("<b>Emily:</b> Then you're good. They wanted you, or they would have never picked you. It's the same for me here.");
		MessageBox.AddMessage("<b>You:</b> Yeah, I guess. I start working on Monday. I was so glad to get this room.");
		MessageBox.AddMessage("<b>Emily:</b> So my leaving is helping you get settled. It all works out in the end.");
		MessageBox.AddMessage("<b>You:</b> You know I'm going to have to tell Hannah about the hole in the floor, right?");
		MessageBox.AddMessage("<b>Emily:</b> Er... Do you really have to? She's going to be so furious.");
		MessageBox.AddMessage("<b>You:</b> I'm sure she's already been there.");
		MessageBox.AddMessage("<b>Emily:</b> I guess. She did specifically ask me not to tear up the carpet though.");
		MessageBox.AddMessage("<b>You:</b> How long were you here?");
		MessageBox.AddMessage("<b>Emily:</b> Like three years or so. Hannah's a good person. I wish she could stay in one place though.");
		MessageBox.AddMessage("<b>You:</b> She's already off to another conference.");
		MessageBox.AddMessage("<b>Emily:</b> That's her. Hey listen, I need to get going. It's 8PM here and the phone is about to cut out for the night.");
		MessageBox.AddMessage("<b>You:</b> Ok, but call back. I'm sure Hannah will want to hear from you. Well, after she gets done yelling.");
		MessageBox.AddMessage("<b>Emily:</b> I will. Have a good rest of your day, and good luck on Monday! Have to go now, bye bye!");

		m.onFinish = () => {
			SceneManager.LoadScene("End");
		};
	}
}
